﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WebSocketSharp;
using WebSocketSharp.Server;

namespace Websoket.Server
{
    public class Chat : WebSocketBehavior
    {
        private  Dictionary<string,string> nameList=new Dictionary<string, string>();
        protected override async Task OnMessage(MessageEventArgs e)
        {

            StreamReader reader = new StreamReader(e.Data);
            string text = reader.ReadToEnd();
            try
            {
                var obj = Json.JsonParser.Deserialize<JsonDto>(text);
                Console.WriteLine("收到消息：" + obj.content + " 类型：" + obj.type + " id:" + Id);
                switch (obj.type)
                {
                    //正常聊天
                    case "1":
                        obj.name = nameList[Id];
                        await Sessions.Broadcast(Json.JsonParser.Serialize(obj));
                        break;
                    //修改名称
                    case "2":
                        Console.WriteLine("{0}修改名称{1}",nameList[Id],obj.content);
                        Broadcast(string.Format("{0}修改名称{1}", nameList[Id], obj.content),"3");
                        nameList[Id] = obj.content;
                        break;
                    default:
                        await Sessions.Broadcast(text);
                        break;

                }
            }
            catch (Exception exception)
            {
                Console.WriteLine(exception);
            }
          
            //await Send(text);
        }
        protected override async Task OnClose(CloseEventArgs e)
        {
            Console.WriteLine("连接关闭" + Id);
            Broadcast(string.Format("{0}下线，共有{1}人在线", nameList[Id], Sessions.Count), "3");
            nameList.Remove(Id);
        }

        protected override async Task OnError(WebSocketSharp.ErrorEventArgs e) 
        {
            var el = e;
        }

        protected override async Task OnOpen()
        {
            Console.WriteLine("建立连接"+Id);
            nameList.Add(Id,"游客"+Sessions.Count);
            Broadcast(string.Format("{0}上线了，共有{1}人在线", nameList[Id],Sessions.Count), "3");

        }

        private void Broadcast(string msg, string type = "1")
        {
            var data= new  JsonDto(){content = msg,type = type,name = nameList[Id]};
            Sessions.Broadcast(Json.JsonParser.Serialize(data));
        }


    }

    public class Program
    {
        public static void Main(string[] args)
        {
            var wssv = new WebSocketServer(null,8080);
            wssv.AddWebSocketService<Chat>("/Chat");
            wssv.Start();
            Console.ReadKey(true);
            wssv.Stop();
        }
    }
}
